OGRE-Next: Ogre::Mesh Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Attributes | List of all members
Ogre::Mesh Class Referencefinal
Core » Resources

Resource holding data about 3D mesh. More...

`#include <OgreMesh2.h>`

Inheritance diagram for Ogre::Mesh:
[legend]

## Public Types
typedef FastArray< Real > | LodValueArray
typedef vector< SubMesh * >::type | SubMeshVec
Public Types inherited from Ogre::Resource
enum | LoadingFlags { LF_DEFAULT = 0 , LF_INCLUDE_NON_RELOADABLE = 1 , LF_ONLY_UNREFERENCED = 2 , LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3 , LF_PRESERVE_STATE = 4 , LF_MARKED_FOR_RELOAD = 8 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED , LOADSTATE_LOADING , LOADSTATE_LOADED , LOADSTATE_UNLOADING , LOADSTATE_PREPARED , LOADSTATE_PREPARING , LOADSTATE_UNLOADED_MARKED_FOR_RELOAD }
| Enum identifying the loading state of the resource. More...

## Public Member Functions
| Mesh (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, VaoManager *vaoManager, bool isManual=false, ManualResourceLoader *loader=0)
| Default constructor - used by MeshManager.
| ~Mesh () override
const LodValueArray * | _getLodValueArray () const
VaoManager * | _getVaoManager () const
| will return the vao manager that this mesh will use for creating and destroying array objects
void | _notifySkeleton (v1::SkeletonPtr &pSkel)
| Internal notification, used to tell the Mesh which Skeleton to use without loading it.
void | _setBoundingSphereRadius (Real radius)
| Manually set the bounding radius.
void | _setBounds (const Aabb &bounds, bool pad=true)
| Manually set the bounding box for this Mesh.
void | _setHashForCaches (const uint64 hash[2])
| Explicitly set a hash for caches. See Mesh::getHashForCaches.
void | _setLodInfo (unsigned short numLevels)
| Internal methods for loading LOD, do not use.
void | _setVaoManager (VaoManager *vaoManager)
| will manually set the vao manager the mesh will use when it loads.
void | _updateBoundsFromVertexBuffers (bool pad=false)
| Automatically update the bounding radius and bounding box for this Mesh.
void | addBoneAssignment (const VertexBoneAssignment &vertBoneAssign)
| Assigns a vertex to a bone with a given weight, for skeletal animation.
void | arrangeEfficient (bool halfPos, bool halfTexCoords, bool qTangents)
| Converts this SubMesh to an efficient arrangement.
void | clearBoneAssignments ()
| Removes all bone assignments for this mesh.
MeshPtr | clone (const String &newName, const String &newGroup=BLANKSTRING, int vertexBufferType=-1, int indexBufferType=-1)
| Makes a copy of this mesh object and gives it a new name.
void | copy (const MeshPtr &destination, int vertexBufferType=-1, int indexBufferType=-1)
| Will copy this mesh into the destination mesh.
SubMesh * | createSubMesh (size_t index=~0u)
| Creates a new SubMesh.
void | dearrangeToInefficient ()
| Reverts the effects from arrangeEfficient by converting all 16-bit half float back to 32-bit float; and QTangents to Normal, Tangent + Reflection representation, which are more compatible for doing certain operations vertex operations in the CPU.
void | destroySubMesh (unsigned index)
| Destroy a SubMesh with the given index.
const Aabb & | getAabb () const
| Get the axis-aligned bounding box for this mesh.
Real | getBoundingSphereRadius () const
| Gets the radius of the bounding sphere surrounding this mesh.
const uint64 * | getHashForCaches () const
| Returns an array of [2] containing a hash for use in caches.
BufferType | getIndexBufferDefaultType () const
| Gets the usage setting for this meshes index buffers.
uint16 | getLodIndex (Real value) const
| Retrieves the level of detail index for the given LOD value.
const String & | getLodStrategyName () const
| Returns the name of the Lod strategy the user lod values have been calibrated for.
uint16 | getNumLodLevels () const
| Returns the number of levels of detail that this mesh supports.
unsigned | getNumSubMeshes () const
| Gets the number of sub meshes which comprise this mesh.
const SkeletonDefPtr & | getSkeleton () const
| Gets a pointer to any linked Skeleton.
const String & | getSkeletonName () const
| Gets the name of any linked Skeleton.
SubMesh * | getSubMesh (unsigned index) const
| Gets a pointer to the submesh indicated by the index.
const SubMeshVec & | getSubMeshes () const
| Gets an iterator over the available submeshes.
const SubMeshNameMap & | getSubMeshNameMap () const
| Gets a reference to the optional name assignments of the SubMeshes.
BufferType | getVertexBufferDefaultType () const
| Gets the usage setting for this meshes vertex buffers.
bool | hasIndependentShadowMappingVaos () const
| Returns true if the shadow mapping buffers do not just reference the real buffers, but are rather their own separate set of optimized geometry.
bool | hasSkeleton () const
| Returns true if this Mesh has a linked Skeleton.
bool | hasValidShadowMappingVaos () const
| Returns true if the mesh is ready for rendering with valid shadow mapping Vaos Otherwise prepareForShadowMapping must be called on this mesh.
void | importV1 (v1::Mesh *mesh, bool halfPos, bool halfTexCoords, bool qTangents, bool halfPose=true)
| Imports a v1 mesh to this mesh, with optional optimization conversions.
bool | isIndexBufferShadowed () const
| Gets whether or not this meshes index buffers are shadowed.
bool | isVertexBufferShadowed () const
| Gets whether or not this meshes vertex buffers are shadowed.
void | nameSubMesh (const String &name, unsigned index)
| Gives a name to a SubMesh. Note, only first 65536 submeshes could be named.
void | prepareForShadowMapping (bool forceSameBuffers)
void | removeLodLevels ()
| Internal methods for loading LOD, do not use.
void | setIndexBufferPolicy (BufferType bufferType, bool shadowBuffer=false)
| Sets the policy for the index buffers to be used when loading this Mesh.
void | setLodStrategyName (const String &name)
void | setSkeletonName (const String &skelName)
| Calculates.
void | setVertexBufferPolicy (BufferType bufferType, bool shadowBuffer=false)
| Sets the policy for the vertex buffers to be used when loading this Mesh.
void | unnameSubMesh (const String &name)
| Removes a name from a SubMesh.
Public Member Functions inherited from Ogre::Resource
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
virtual void | _fireLoadingComplete (bool wasBackgroundLoaded)
| Firing of loading complete event.
virtual void | _firePreparingComplete (bool wasBackgroundLoaded)
| Firing of preparing complete event.
virtual void | _fireUnloadingComplete ()
| Firing of unloading complete event.
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
virtual ResourceManager * | getCreator ()
| Gets the manager which created this resource.
virtual const String & | getGroup () const
| Gets the group which this resource is a member of.
virtual ResourceHandle | getHandle () const
virtual LoadingState | getLoadingState () const
| Returns the current loading state.
virtual const String & | getName () const
| Gets resource name.
virtual const String & | getOrigin () const
| Get the origin of this resource, e.g.
virtual size_t | getSize () const
| Retrieves info about the size of the resource.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
virtual bool | isBackgroundLoaded () const
| Returns whether this Resource has been earmarked for background loading.
virtual bool | isLoaded () const
| Returns true if the Resource has been loaded, false otherwise.
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
virtual bool | isManuallyLoaded () const
| Is this resource manually loaded?
virtual bool | isPrepared () const
| Returns true if the Resource has been prepared, false otherwise.
virtual bool | isReloadable () const
| Returns true if the Resource is reloadable, false otherwise.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
bool | markForReload ()
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | setManuallyLoaded (bool isManual)
| Set "Is this resource manually loaded?".
virtual void | setToLoaded ()
| Change the Resource loading state to loaded.
virtual void | touch ()
| 'Touches' the resource to indicate it has been used.
virtual void | unload ()
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary ()
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary () const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters () const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.

## Static Public Attributes
static bool | msOptimizeForShadowMapping
| When this bool is false, prepareForShadowMapping will use the same Vaos for both regular and shadow mapping rendering.
static bool | msUseTimestampAsHash
| If a mesh file didn't save hash information (see Mesh::getHashForCaches) and msUseTimestampAsHash == true; then we use the file last modified timestamp as hash (it's better than nothing).

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
Public Attributes inherited from Ogre::Resource
| OGRE_AUTO_MUTEX

## Detailed Description

Resource holding data about 3D mesh.

Remarks
  This class holds the data used to represent a discrete 3-dimensional object. Mesh data usually contains more than just vertices and triangle information; it also includes references to materials (and the faces which use them), level-of-detail reduction information, convex hull definition, skeleton/bones information, keyframe animation etc. However, it is important to note the emphasis on the word 'discrete' here. This class does not cover the large-scale sprawling geometry found in level / landscape data.

  Multiple world objects can (indeed should) be created from a single mesh object - see the Entity class for more info. The mesh object will have it's own default material properties, but potentially each world instance may wish to customise the materials from the original. When the object is instantiated into a scene node, the mesh material properties will be taken by default but may be changed. These properties are actually held at the SubMesh level since a single mesh may have parts with different materials.

  As described above, because the mesh may have sections of differing material properties, a mesh is inherently a compound construct, consisting of one or more SubMesh objects. However, it strongly 'owns' it's SubMeshes such that they are loaded / unloaded at the same time. This is contrary to the approach taken to hierarchically related (but loosely owned) scene nodes, where data is loaded / unloaded separately. Note also that mesh sub-sections (when used in an instantiated object) share the same scene node as the parent.

## Member Typedef Documentation

## ◆ LodValueArray

typedef FastArray<Real> Ogre::Mesh::LodValueArray

## ◆ SubMeshVec

typedef vector<SubMesh*>::type Ogre::Mesh::SubMeshVec

## Constructor & Destructor Documentation

## ◆ Mesh()

Ogre::Mesh::Mesh | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | VaoManager * | vaoManager,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0 )

Default constructor - used by MeshManager.

Warning
  Do not call this method directly.

## ◆ ~Mesh()

Ogre::Mesh::~Mesh | ( |  | ) |
| override

## Member Function Documentation

## ◆ _getLodValueArray()

const LodValueArray * Ogre::Mesh::_getLodValueArray | ( |  | ) | const
| inline

## ◆ _getVaoManager()

VaoManager * Ogre::Mesh::_getVaoManager | ( |  | ) | const
| inline

will return the vao manager that this mesh will use for creating and destroying array objects

## ◆ _notifySkeleton()

void Ogre::Mesh::_notifySkeleton | ( | v1::SkeletonPtr & | pSkel | ) |

Internal notification, used to tell the Mesh which Skeleton to use without loading it.

Remarks
  This is only here for unusual situation where you want to manually set up a Skeleton. Best to let OGRE deal with this, don't call it yourself unless you really know what you're doing.

## ◆ _setBoundingSphereRadius()

void Ogre::Mesh::_setBoundingSphereRadius | ( | Real | radius | ) |

Manually set the bounding radius.

Remarks
  Calling this method is required when building manual meshes now, because OGRE can no longer update the bounds for you, because it cannot necessarily read vertex data back from the vertex buffers which this mesh uses (they very well might be write-only, and even if they are not, reading data from a hardware buffer is a bottleneck).

## ◆ _setBounds()

void Ogre::Mesh::_setBounds | ( | const Aabb & | bounds,
|  | bool | pad = true )

Manually set the bounding box for this Mesh.

Remarks
  Calling this method is required when building manual meshes now, because OGRE can no longer update the bounds for you, because it cannot necessarily read vertex data back from the vertex buffers which this mesh uses (they very well might be write-only, and even if they are not, reading data from a hardware buffer is a bottleneck).

Parameters

  pad | If true, a certain padding will be added to the bounding box to separate it from the mesh

## ◆ _setHashForCaches()

void Ogre::Mesh::_setHashForCaches | ( | const uint64 | hash[2] | ) |

Explicitly set a hash for caches. See Mesh::getHashForCaches.

## ◆ _setLodInfo()

void Ogre::Mesh::_setLodInfo | ( | unsigned short | numLevels | ) |

Internal methods for loading LOD, do not use.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ _setVaoManager()

void Ogre::Mesh::_setVaoManager | ( | VaoManager * | vaoManager | ) |
| inline

will manually set the vao manager the mesh will use when it loads.

setting this when the mesh is already loaded will cause a crash on unload, use with caution!

## ◆ _updateBoundsFromVertexBuffers()

void Ogre::Mesh::_updateBoundsFromVertexBuffers | ( | bool | pad = false | ) |

Automatically update the bounding radius and bounding box for this Mesh.

Remarks
  Calling this method is required when building manual meshes. However it is recommended to use _setBounds and _setBoundingSphereRadius instead, because the vertex buffer may not have a shadow copy in the memory. Reading back the buffer from video memory is very slow!

Parameters

  pad | If true, a certain padding will be added to the bounding box to separate it from the mesh

## ◆ addBoneAssignment()

void Ogre::Mesh::addBoneAssignment | ( | const VertexBoneAssignment & | vertBoneAssign | ) |

Assigns a vertex to a bone with a given weight, for skeletal animation.

Remarks
  This method is only valid after calling setSkeletonName. Since this is a one-off process there exists only 'addBoneAssignment' and 'clearBoneAssignments' methods, no 'editBoneAssignment'. You should not need to modify bone assignments during rendering (only the positions of bones) and OGRE reserves the right to do some internal data reformatting of this information, depending on render system requirements.

  This method is for assigning weights to the shared geometry of the Mesh. To assign weights to the per-SubMesh geometry, see the equivalent methods on SubMesh.

## ◆ arrangeEfficient()

void Ogre::Mesh::arrangeEfficient | ( | bool | halfPos,
|  | bool | halfTexCoords,
|  | bool | qTangents )

Converts this SubMesh to an efficient arrangement.

See Mesh::importV1 for an explanation on the parameters.

See also
  dearrangeEfficientToInefficient to perform the opposite operation.

## ◆ clearBoneAssignments()

void Ogre::Mesh::clearBoneAssignments | ( |  | ) |

Removes all bone assignments for this mesh.

Remarks
  This method is for modifying weights to the shared geometry of the Mesh. To assign weights to the per-SubMesh geometry, see the equivalent methods on SubMesh.

## ◆ clone()

MeshPtr Ogre::Mesh::clone | ( | const String & | newName,
|  | const String & | newGroup = BLANKSTRING,
|  | int | vertexBufferType = -1,
|  | int | indexBufferType = -1 )

Makes a copy of this mesh object and gives it a new name.

Remarks
  This is useful if you want to tweak an existing mesh without affecting the original one. The newly cloned mesh is registered with the MeshManager under the new name.

Parameters

  newName | The name to give the clone.
  newGroup | Optional name of the new group to assign the clone to; if you leave this blank, the clone will be assigned to the same group as this Mesh.
  vertexBufferType | See BufferType. Must be set to a valid BufferType. Pass a negative value to keep the same type of the original buffer being cloned.
  indexBufferType | See BufferType. Must be set to a valid BufferType. Pass a negative value to keep the same type of the original buffer being cloned.

References Ogre::BLANKSTRING.

## ◆ copy()

void Ogre::Mesh::copy | ( | const MeshPtr & | destination,
|  | int | vertexBufferType = -1,
|  | int | indexBufferType = -1 )

Will copy this mesh into the destination mesh.

Remarks
  similar to clone however will copy into a mesh you define rather than creating one for you.

Parameters

  destination | The mesh that will be the destination for the copy of *this
  vertexBufferType | See BufferType. Must be set to a valid BufferType. Pass a negative value to keep the same type of the original buffer being cloned.
  indexBufferType | See BufferType. Must be set to a valid BufferType. Pass a negative value to keep the same type of the original buffer being cloned.

## ◆ createSubMesh()

SubMesh * Ogre::Mesh::createSubMesh | ( | size_t | index = ~0u | ) |

Creates a new SubMesh.

Remarks
  Method for manually creating geometry for the mesh. Note - use with extreme caution - you must be sure that you have set up the geometry properly.

Parameters

  index | Optional param that will insert the submesh at the specified index. This should be less than getNumSubMeshes(), otherwise it indicates the new submesh will simply be appended to the submesh list.

References SubMesh.

## ◆ dearrangeToInefficient()

void Ogre::Mesh::dearrangeToInefficient | ( |  | ) |

Reverts the effects from arrangeEfficient by converting all 16-bit half float back to 32-bit float; and QTangents to Normal, Tangent + Reflection representation, which are more compatible for doing certain operations vertex operations in the CPU.

## ◆ destroySubMesh()

void Ogre::Mesh::destroySubMesh | ( | unsigned | index | ) |

Destroy a SubMesh with the given index.

Note
  This will invalidate the contents of any existing Entity, or any other object that is referring to the SubMesh list. Entity will detect this and reinitialise, but it is still a disruptive action.

## ◆ getAabb()

const Aabb & Ogre::Mesh::getAabb | ( |  | ) | const

Get the axis-aligned bounding box for this mesh.

## ◆ getBoundingSphereRadius()

Real Ogre::Mesh::getBoundingSphereRadius | ( |  | ) | const

Gets the radius of the bounding sphere surrounding this mesh.

## ◆ getHashForCaches()

const uint64 * Ogre::Mesh::getHashForCaches | ( |  | ) | const
| inline

Returns an array of [2] containing a hash for use in caches.

A value of { 0, 0 } should be treated as not initialized.

How this cache is calculated is unknown and could just be a filesystem timestamp rather than a checksum.

When callers see that: getCacheHash()[i] != savedHash[i]

they should treat as if the mesh has changed and the cache entry became stale

## ◆ getIndexBufferDefaultType()

BufferType Ogre::Mesh::getIndexBufferDefaultType | ( |  | ) | const
| inline

Gets the usage setting for this meshes index buffers.

## ◆ getLodIndex()

uint16 Ogre::Mesh::getLodIndex | ( | Real | value | ) | const

Retrieves the level of detail index for the given LOD value.

Note
  The value passed in is the 'transformed' value. If you are dealing with an original source value (e.g. distance), use LodStrategy::transformUserValue to turn this into a lookup value.

## ◆ getLodStrategyName()

const String & Ogre::Mesh::getLodStrategyName | ( |  | ) | const
| inline

Returns the name of the Lod strategy the user lod values have been calibrated for.

## ◆ getNumLodLevels()

uint16 Ogre::Mesh::getNumLodLevels | ( |  | ) | const

Returns the number of levels of detail that this mesh supports.

Remarks
  This number includes the original model.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ getNumSubMeshes()

unsigned Ogre::Mesh::getNumSubMeshes | ( |  | ) | const

Gets the number of sub meshes which comprise this mesh.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ getSkeleton()

const SkeletonDefPtr & Ogre::Mesh::getSkeleton | ( |  | ) | const
| inline

Gets a pointer to any linked Skeleton.

Returns
  Weak reference to the skeleton - copy this if you want to hold a strong pointer.

## ◆ getSkeletonName()

const String & Ogre::Mesh::getSkeletonName | ( |  | ) | const

Gets the name of any linked Skeleton.

## ◆ getSubMesh()

SubMesh * Ogre::Mesh::getSubMesh | ( | unsigned | index | ) | const

Gets a pointer to the submesh indicated by the index.

References SubMesh.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ getSubMeshes()

const SubMeshVec & Ogre::Mesh::getSubMeshes | ( |  | ) | const
| inline

Gets an iterator over the available submeshes.

## ◆ getSubMeshNameMap()

const SubMeshNameMap & Ogre::Mesh::getSubMeshNameMap | ( |  | ) | const
| inline

Gets a reference to the optional name assignments of the SubMeshes.

## ◆ getVertexBufferDefaultType()

BufferType Ogre::Mesh::getVertexBufferDefaultType | ( |  | ) | const
| inline

Gets the usage setting for this meshes vertex buffers.

## ◆ hasIndependentShadowMappingVaos()

bool Ogre::Mesh::hasIndependentShadowMappingVaos | ( |  | ) | const

Returns true if the shadow mapping buffers do not just reference the real buffers, but are rather their own separate set of optimized geometry.

## ◆ hasSkeleton()

bool Ogre::Mesh::hasSkeleton | ( |  | ) | const
| inline

Returns true if this Mesh has a linked Skeleton.

## ◆ hasValidShadowMappingVaos()

bool Ogre::Mesh::hasValidShadowMappingVaos | ( |  | ) | const

Returns true if the mesh is ready for rendering with valid shadow mapping Vaos Otherwise prepareForShadowMapping must be called on this mesh.

## ◆ importV1()

void Ogre::Mesh::importV1 | ( | v1::Mesh * | mesh,
|  | bool | halfPos,
|  | bool | halfTexCoords,
|  | bool | qTangents,
|  | bool | halfPose = true )

Imports a v1 mesh to this mesh, with optional optimization conversions.

This mesh must be in unloaded state. Resulting mesh would be non-reloadable, use MeshManager::createByImportingV1 to create mesh that will survive device lost event.

Remarks
  The vertex stream will be converted to a single interleaved buffer; i.e. if the original mesh had 3 vertex buffers: [1] = POSITION, POSITION, POSITION, POSITION, ... [2] = NORMALS, NORMALS, NORMALS, NORMALS, ... [3] = UV, UV, UV, UV, ... then the v2 mesh will have only 1 vertex buffer: [1] = POSITION NORMALS UV, POS NORM UV, POS NORM UV, POS NORM UV, ...

Parameters

  mesh | The source v1 mesh to convert from. You can unload or delete this pointer afterwards.
  halfPos | True if you want to convert the position data to VET_HALF4 format. Recommended on desktop to reduce memory and bandwidth requirements. Rarely the extra precision is needed. Unfortuntately on mobile, not all ES2 devices support VET_HALF4.
  halfTexCoords | True if you want to convert the position data to VET_HALF2 or VET_HALF4 format. Same recommendations as halfPos.
  qTangents | True if you want to generate tangent and reflection information (modifying the original v1 mesh) and convert this data to a QTangent, requiring VET_SHORT4_SNORM (8 bytes vs 28 bytes to store normals, tangents and reflection). Needs much less space, trading for more ALU ops in the vertex shader for decoding the QTangent. Highly recommended on both desktop and mobile if you need tangents (i.e. normal mapping).
  halfPose | True if you want the pose buffer to have pixel format PF_FLOAT16_RGBA which uses significantly less memory. Otherwise it is created with pixel format PF_FLOAT32_RGBA. Rarely the extra precision is needed.

## ◆ isIndexBufferShadowed()

bool Ogre::Mesh::isIndexBufferShadowed | ( |  | ) | const
| inline

Gets whether or not this meshes index buffers are shadowed.

## ◆ isVertexBufferShadowed()

bool Ogre::Mesh::isVertexBufferShadowed | ( |  | ) | const
| inline

Gets whether or not this meshes vertex buffers are shadowed.

## ◆ nameSubMesh()

void Ogre::Mesh::nameSubMesh | ( | const String & | name,
|  | unsigned | index )

Gives a name to a SubMesh. Note, only first 65536 submeshes could be named.

## ◆ prepareForShadowMapping()

void Ogre::Mesh::prepareForShadowMapping | ( | bool | forceSameBuffers | ) |

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ removeLodLevels()

void Ogre::Mesh::removeLodLevels | ( |  | ) |

Internal methods for loading LOD, do not use.

Removes all LOD data from this Mesh.

## ◆ setIndexBufferPolicy()

void Ogre::Mesh::setIndexBufferPolicy | ( | BufferType | bufferType,
|  | bool | shadowBuffer = false )

Sets the policy for the index buffers to be used when loading this Mesh.

See also
  setVertexBufferPolicy

## ◆ setLodStrategyName()

void Ogre::Mesh::setLodStrategyName | ( | const String & | name | ) |
| inline

## ◆ setSkeletonName()

void Ogre::Mesh::setSkeletonName | ( | const String & | skelName | ) |

Calculates.

Remarks
  Calling this method is required when building manual meshes. However it is recommended to use _setBounds and _setBoundingSphereRadius instead, because the vertex buffer may not have a shadow copy in the memory. Reading back the buffer from video memory is very slow! Sets the name of the skeleton this Mesh uses for animation.
  Meshes can optionally be assigned a skeleton which can be used to animate the mesh through bone assignments. The default is for the Mesh to use no skeleton. Calling this method with a valid skeleton filename will cause the skeleton to be loaded if it is not already (a single skeleton can be shared by many Mesh objects).

Parameters

  skelName | The name of the .skeleton file to use, or an empty string to use no skeleton

## ◆ setVertexBufferPolicy()

void Ogre::Mesh::setVertexBufferPolicy | ( | BufferType | bufferType,
|  | bool | shadowBuffer = false )

Sets the policy for the vertex buffers to be used when loading this Mesh.

Remarks
  By default, when loading the Mesh, immutable buffers will be used where possible in order to improve rendering performance. However, such buffers cannot be manipulated on the fly by CPU code (although shader code can). If you wish to use the CPU to modify these buffers, you should call this method. Note, however, that it only takes effect after the Mesh has been reloaded. Note that you still have the option of manually repacing the buffers in this mesh with your own if you see fit too, in which case you don't need to call this method since it only affects buffers created by the mesh itself.

  You can define the approach to a Mesh by changing the default parameters to MeshManager::load if you wish; this means the Mesh is loaded with those options the first time instead of you having to reload the mesh after changing these options.

Parameters

  bufferType | The buffer type flags, which by default is BT_IMMUTABLE
  shadowBuffer | If set to `true`, the vertex buffers will be created with a system memory shadow buffer. You should set this if you want to be able to read from the buffer, because reading from a hardware buffer is a no-no.

## ◆ unnameSubMesh()

void Ogre::Mesh::unnameSubMesh | ( | const String & | name | ) |

Removes a name from a SubMesh.

## Member Data Documentation

## ◆ msOptimizeForShadowMapping

bool Ogre::Mesh::msOptimizeForShadowMapping
| static

When this bool is false, prepareForShadowMapping will use the same Vaos for both regular and shadow mapping rendering.

When it's true, it will calculate an optimized version to speed up shadow map rendering (uses a bit more GPU VRAM). Large meshes can take long to optimize thus it is recommended to perform this offline and save it into the mesh file. It's off by default.

See also
  Ogre::Mesh::msOptimizeForShadowMapping for the v2 version
  Ogre::v1::Mesh::msOptimizeForShadowMapping for the v1 version

## ◆ msUseTimestampAsHash

bool Ogre::Mesh::msUseTimestampAsHash
| static

If a mesh file didn't save hash information (see Mesh::getHashForCaches) and msUseTimestampAsHash == true; then we use the file last modified timestamp as hash (it's better than nothing).

By default this is disabled since it's often not needed and can't hurt loading times with unnecessary disk access

The documentation for this class was generated from the following file:

- OgreMesh2.h